using System;
using System.IO;
using System.Runtime.InteropServices;
using Avalonia;
using Avalonia.Controls.ApplicationLifetimes;
using Avalonia.Markup.Xaml;
using DiscordRPC;
using ManagedBass;
using Newtonsoft.Json;
using Ocarina2.Models;
using Ocarina2.ViewModels;
using Ocarina2.Views;

namespace Ocarina2;

public partial class App : Application
{
    public static readonly DiscordRpcClient Client = new("690238946378121296");
    public override void Initialize()
    {
        Bass.Init();
        Client.Initialize();
        AvaloniaXamlLoader.Load(this);
    }

    public override void OnFrameworkInitializationCompleted()
    {
        var l = Language.Load("en_US");

        if (ApplicationLifetime is IClassicDesktopStyleApplicationLifetime desktop)
        {
            desktop.MainWindow = new MainWindow
            {
                DataContext = new MainWindowViewModel(l),
            };
        }

        base.OnFrameworkInitializationCompleted();
    }
}